Index: TWiki/UI/Manage.pm
===================================================================
--- TWiki/UI/Manage.pm	(revision 13172)
+++ TWiki/UI/Manage.pm	(working copy)
@@ -1037,7 +1019,7 @@
                          );
     }
     unless( $search ) {
-        $search = ($session->{i18n}->maketext('(none)'));
+        $search = ($TWiki::I18N->maketext('(none)'));
     } else {
         $search = CGI::start_table().$search.CGI::end_table();
     }
@@ -1060,25 +1042,25 @@
                             $refs->{$entry} ));
     }
     unless( $search ) {
-        $search = ($session->{i18n}->maketext('(none)'));
+        $search = ($TWiki::I18N->maketext('(none)'));
     } else {
         $search = CGI::start_table().$search.CGI::end_table();
     }
     $tmpl =~ s/%LOCAL_SEARCH%/$search/go;
 
-    $tmpl = $session->handleCommonTags(
+    $tmpl = $TWiki::SESSION->handleCommonTags(
         $tmpl, $oldWeb, $TWiki::cfg{HomeTopicName} );
-    $tmpl = $session->{renderer}->getRenderedVersion(
+    $tmpl = $TWiki::RENDER->getRenderedVersion(
         $tmpl, $oldWeb, $TWiki::cfg{HomeTopicName} );
-    $session->writeCompletePage( $tmpl );
+    $TWiki::SESSION->writeCompletePage( $tmpl );
 }
 
 # Returns the list of topics that have been found that refer
 # to the renamed topic. Returns a list of topics.
 sub _getReferringTopicsListFromURL {
-    my( $session, $oldWeb, $oldTopic, $newWeb, $newTopic ) = @_;
+    my( $TWiki::SESSION, $oldWeb, $oldTopic, $newWeb, $newTopic ) = @_;
 
-    my $query = $session->{cgiQuery};
+    my $query = $TWiki::SESSION->{cgiQuery};
     my @result;
     foreach my $topic ( $query->param( 'referring_topics' ) ) {
         push @result, $topic;
@@ -1088,9 +1070,9 @@
 
 =pod
 
----++ StaticMethod getReferringTopics($session, $web, $topic, $allWebs) -> \%matches
+---++ StaticMethod getReferringTopics($TWiki::SESSION, $web, $topic, $allWebs) -> \%matches
 
-   * =$session= - the session
+   * =$TWiki::SESSION= - the session
    * =$web= - web to search for
    * =$topic= - topic to search for
    * =$allWebs= - 0 to search $web only. 1 to search all webs _except_ $web.
@@ -1099,20 +1081,20 @@
 =cut
 
 sub getReferringTopics {
-    my( $session, $web, $topic, $allWebs ) = @_;
-    my $store = $session->{store};
-    my $renderer = $session->{renderer};
+    my( $TWiki::SESSION, $web, $topic, $allWebs ) = @_;
+
+    my $renderer = $TWiki::RENDER;
     $web =~ s#\.#/#go;
     my @webs = ( $web );
 
     if( $allWebs ) {
-        @webs = $store->getListOfWebs();
+        @webs = $TWiki::STORE->getListOfWebs();
     }
 
     my %results;
     foreach my $searchWeb ( @webs ) {
         next if( $allWebs && $searchWeb eq $web );
-        my @topicList = $store->getTopicNames( $searchWeb );
+        my @topicList = $TWiki::STORE->getTopicNames( $searchWeb );
         my $searchString;
         my $webString = $web;
         $webString =~ s#[\./]#[\\.\\/]#go;
@@ -1133,7 +1115,7 @@
         # Note use of \< and \> to match the empty string at the
         # edges of a word.
 
-        my $matches = $store->searchInWebContent
+        my $matches = $TWiki::STORE->searchInWebContent
           ( $searchString,
             $searchWeb, \@topicList,
             { casesensitive => 1, type => 'regex' } );
@@ -1158,10 +1140,10 @@
 # SMELL: this might be done more efficiently if it was behind the
 # store interface
 sub _updateReferringTopics {
-    my ( $session, $oldWeb, $oldTopic, $newWeb, $newTopic, $refs ) = @_;
-    my $store = $session->{store};
-    my $renderer = $session->{renderer};
-    my $user = $session->{user};
+    my ( $TWiki::SESSION, $oldWeb, $oldTopic, $newWeb, $newTopic, $refs ) = @_;
+
+    my $renderer = $TWiki::RENDER;
+    my $user = $TWiki::SESSION->{user};
     my $options =
       {
        pre => 1, # process lines in PRE blocks
@@ -1175,13 +1157,13 @@
 
     foreach my $item ( @$refs ) {
         my( $itemWeb, $itemTopic ) =
-          $session->normalizeWebTopicName( '', $item );
+          $TWiki::SESSION->normalizeWebTopicName( '', $item );
 
-        if ( $store->topicExists($itemWeb, $itemTopic) ) {
-            $store->lockTopic( $user, $itemWeb, $itemTopic );
+        if ( $TWiki::STORE->topicExists($itemWeb, $itemTopic) ) {
+            $TWiki::STORE->lockTopic( $user, $itemWeb, $itemTopic );
             try {
                 my( $meta, $text ) =
-                  $store->readTopic( undef, $itemWeb, $itemTopic, undef );
+                  $TWiki::STORE->readTopic( undef, $itemWeb, $itemTopic, undef );
                 $options->{inWeb} = $itemWeb;
 
                 $text = $renderer->forEachLine
@@ -1190,14 +1172,14 @@
                   ( qw/^(FIELD|FORM|TOPICPARENT)$/, undef,
                     \&TWiki::Render::replaceTopicReferences, $options );
 
-                $store->saveTopic( $user, $itemWeb, $itemTopic,
+                $TWiki::STORE->saveTopic( $user, $itemWeb, $itemTopic,
                                    $text, $meta,
                                    { minor => 1 } );
             } catch TWiki::AccessControlException with {
                 my $e = shift;
-                $session->writeWarning( $e->stringify() );
+                $TWiki::SESSION->writeWarning( $e->stringify() );
             } finally {
-                $store->unlockTopic( $user, $itemWeb, $itemTopic );
+                $TWiki::STORE->unlockTopic( $user, $itemWeb, $itemTopic );
             };
         }
     }
@@ -1205,10 +1187,10 @@
 
 # Update pages that refer to a web that is being renamed/moved.
 sub _updateWebReferringTopics {
-    my ( $session, $oldWeb, $newWeb, $refs ) = @_;
-    my $store = $session->{store};
-    my $renderer = $session->{renderer};
-    my $user = $session->{user};
+    my ( $TWiki::SESSION, $oldWeb, $newWeb, $refs ) = @_;
+
+    my $renderer = $TWiki::RENDER;
+    my $user = $TWiki::SESSION->{user};
     my $options =
       {
        oldWeb => $oldWeb,
@@ -1217,13 +1199,13 @@
 
     foreach my $item ( @$refs ) {
         my( $itemWeb, $itemTopic ) =
-          $session->normalizeWebTopicName( '', $item );
+          $TWiki::SESSION->normalizeWebTopicName( '', $item );
 
-        if ( $store->topicExists($itemWeb, $itemTopic) ) {
-            $store->lockTopic( $user, $itemWeb, $itemTopic );
+        if ( $TWiki::STORE->topicExists($itemWeb, $itemTopic) ) {
+            $TWiki::STORE->lockTopic( $user, $itemWeb, $itemTopic );
             try {
                 my( $meta, $text ) =
-                  $store->readTopic( undef, $itemWeb, $itemTopic, undef );
+                  $TWiki::STORE->readTopic( undef, $itemWeb, $itemTopic, undef );
                 $options->{inWeb} = $itemWeb;
 
                 $text = $renderer->forEachLine
@@ -1232,26 +1214,25 @@
                   ( qw/^(FIELD|FORM|TOPICPARENT)$/, undef,
                     \&TWiki::Render::replaceWebReferences, $options );
 
-                $store->saveTopic( $user, $itemWeb, $itemTopic,
+                $TWiki::STORE->saveTopic( $user, $itemWeb, $itemTopic,
                                    $text, $meta,
                                    { minor => 1 } );
             } catch TWiki::AccessControlException with {
                 my $e = shift;
-                $session->writeWarning( $e->stringify() );
+                $TWiki::SESSION->writeWarning( $e->stringify() );
             } finally {
-                $store->unlockTopic( $user, $itemWeb, $itemTopic );
+                $TWiki::STORE->unlockTopic( $user, $itemWeb, $itemTopic );
             };
         }
     }
 }
 
 sub _editSettings {
-    my $session = shift;
-    my $topic = $session->{topicName};
-    my $web = $session->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $web = $TWiki::SESSION->{webName};
 
     my( $meta, $text ) =
-      $session->{store}->readTopic( $session->{user}, $web, $topic, undef );
+      $TWiki::STORE->readTopic( $TWiki::SESSION->{user}, $web, $topic, undef );
     my ( $orgDate, $orgAuth, $orgRev ) = $meta->getRevisionInfo();
 
     my $settings = "";
@@ -1264,31 +1245,29 @@
          ' '.$name.' = '.$value."\n";
     }
 
-    my $skin = $session->getSkin();
-    my $tmpl = $session->{templates}->readTemplate( 'settings', $skin );
-    $tmpl = $session->handleCommonTags( $tmpl, $web, $topic, $meta );
-    $tmpl = $session->{renderer}->getRenderedVersion( $tmpl, $web, $topic );
+    my $skin = $TWiki::SESSION->getSkin();
+    my $tmpl = $TWiki::TEMPLATES->readTemplate( 'settings', $skin );
+    $tmpl = $TWiki::SESSION->handleCommonTags( $tmpl, $web, $topic, $meta );
+    $tmpl = $TWiki::RENDER->getRenderedVersion( $tmpl, $web, $topic );
 
     $tmpl =~ s/%TEXT%/$settings/o;
     $tmpl =~ s/%ORIGINALREV%/$orgRev/g;
 
-    $session->writeCompletePage( $tmpl );
-
+    $TWiki::SESSION->writeCompletePage( $tmpl );
 }
 
 sub _saveSettings {
-    my $session = shift;
-    my $topic = $session->{topicName};
-    my $web = $session->{webName};
-    my $user = $session->{user};
+    my $topic = $TWiki::SESSION->{topicName};
+    my $web = $TWiki::SESSION->{webName};
+    my $user = $TWiki::SESSION->{user};
 
     # set up editing session
     my ( $currMeta, $currText ) =
-      $session->{store}->readTopic( undef, $web, $topic, undef );
-    my $newMeta = new TWiki::Meta( $session, $web, $topic );
+      $TWiki::STORE->readTopic( undef, $web, $topic, undef );
+    my $newMeta = new TWiki::Meta( $web, $topic );
     $newMeta->copyFrom( $currMeta );
 
-    my $query = $session->{cgiQuery};
+    my $query = $TWiki::SESSION->{cgiQuery};
     my $settings = $query->param( 'text' );
     my $originalrev = $query->param( 'originalrev' );
 
@@ -1310,7 +1289,7 @@
     }
 
     try {
-        $session->{store}->saveTopic( $user, $web, $topic,
+        $TWiki::STORE->saveTopic( $user, $web, $topic,
                                     $currText, $newMeta, $saveOpts );
     } catch Error::Simple with {
         throw TWiki::OopsException( 'attention',
@@ -1319,8 +1298,8 @@
                                     topic => $topic,
                                     params => shift->{-text} );
     };
-    my $viewURL = $session->getScriptUrl( 0, 'view', $web, $topic );
-    $session->redirect( $viewURL );
+    my $viewURL = $TWiki::SESSION->getScriptUrl( 0, 'view', $web, $topic );
+    $TWiki::SESSION->redirect( $viewURL );
     return;
 
 }
Index: TWiki/UI/ChangeForm.pm
===================================================================
--- TWiki/UI/ChangeForm.pm	(revision 13172)
+++ TWiki/UI/ChangeForm.pm	(working copy)
@@ -35,20 +35,19 @@
 
 =pod
 
----+ ClassMethod generate( $session, $theWeb, $theTopic, $editaction )
+---+ ClassMethod generate( $theWeb, $theTopic, $editaction )
 
 Generate the page that supports selection of the form.
 
 =cut
 
 sub generate {
-    my( $session, $web, $topic, $editaction ) = @_;
-    ASSERT($session->isa( 'TWiki')) if DEBUG;
+    my( $web, $topic, $editaction ) = @_;
 
-    my $page = $session->{templates}->readTemplate( 'changeform' );
-    my $q = $session->{cgiQuery};
+    my $page = $TWiki::TEMPLATES->readTemplate( 'changeform' );
+    my $q = $TWiki::SESSION->{cgiQuery};
 
-    my $store = $session->{store};
+    my $store = $TWiki::STORE;
     my $formName = $q->param( 'formtemplate' ) || '';
     unless( $formName ) {
         my( $meta, $tmp ) = $store->readTopic( undef, $web, $topic, undef );
@@ -57,7 +56,7 @@
     }
     $formName = 'none' if( !$formName );
 
-    my $prefs = $session->{prefs};
+    my $prefs = $TWiki::PREFS;
     my $legalForms = $prefs->getWebPreferencesValue( 'WEBFORMS', $web );
     $legalForms =~ s/^\s*//;
     $legalForms =~ s/\s*$//;
@@ -78,7 +77,7 @@
            };
         $props->{checked} = 'checked' if $form eq $formName;
         $formList .= CGI::input( $props );
-	my ($formWeb, $formTopic) = $session->normalizeWebTopicName($web, $form);
+	my ($formWeb, $formTopic) = $TWiki::SESSION->normalizeWebTopicName($web, $form);
         my $formLabelContent = '&nbsp;' . ( $store->topicExists( $formWeb, $formTopic ) ? 
 	  '[['.$formWeb.'.'.$formTopic.']['.$form.']]' : $form );
         $formList .= CGI::label( { for => $formElemId}, $formLabelContent );
@@ -91,8 +90,8 @@
     my $redirectTo = $q->param( 'redirectto' ) || '';
     $page =~ s/%REDIRECTTO%/$redirectTo/go;
 
-    $page = $session->handleCommonTags( $page, $web, $topic );
-    $page = $session->{renderer}->getRenderedVersion( $page, $web, $topic );
+    $page = $TWiki::SESSION->handleCommonTags( $page, $web, $topic );
+    $page = $TWiki::RENDER->getRenderedVersion( $page, $web, $topic );
 
     my $text = CGI::hidden( -name => 'text', -value => $q->param( 'text' ) );
     $page =~ s/%TEXT%/$text/go;
Index: TWiki/UI/RDiff.pm
===================================================================
--- TWiki/UI/RDiff.pm	(revision 13172)
+++ TWiki/UI/RDiff.pm	(working copy)
@@ -68,15 +68,15 @@
 #| Return: =$text= | Formatted html text |
 #| TODO: | this should move to Render.pm |
 sub _renderCellData {
-    my( $session, $meta, $data, $web, $topic ) = @_;
+    my( $meta, $data, $web, $topic ) = @_;
     if ( $data ){
         $data =~ s(^%META:FIELD{(.*)}%.*$)
           (_renderAttrs($1,'|*FORM FIELD $title*|$name|$value|'))gem;
         $data =~ s(^%META:([A-Z]+){(.*)}%$)
           ('|*META '.$1.'*|'._renderAttrs($2).'|')gem;
 
-        $data = $session->handleCommonTags( $data, $web, $topic );
-        $data = $session->{renderer}->getRenderedVersion( $data, $web, $topic );
+        $data = $TWiki::SESSION->handleCommonTags( $data, $web, $topic );
+        $data = $TWiki::RENDER->getRenderedVersion( $data, $web, $topic );
         # Match up table tags, remove comments
         if( $data =~ m/<\/?(th|td|table)\b/i ) {
             # data has <th> or <td>, need to fix ables
@@ -135,11 +135,11 @@
 #| TODO: | this should move to Render.pm |
 sub _renderSideBySide
 {
-    my ( $session, $web, $topic, $diffType, $left, $right ) = @_;
+    my ( $web, $topic, $diffType, $left, $right ) = @_;
     my $result = '';
 
-    $left = _renderCellData( $session, $left, $web, $topic );
-    $right = _renderCellData( $session, $right, $web, $topic );
+    $left = _renderCellData( $left, $web, $topic );
+    $right = _renderCellData( $right, $web, $topic );
 
     if ( $diffType eq '-') {
         $result .= _sideBySideRow( $left, $right, '-', 'u' )
@@ -155,9 +155,9 @@
                             class=>$format{l}[1],
                            },
                            CGI::th({align=>'center'},
-                                   ($session->{i18n}->maketext('Line: [_1]',$left))).
+                                   ($TWiki::I18N->maketext('Line: [_1]',$left))).
                            CGI::th({align=>'center'},
-                                   ($session->{i18n}->maketext('Line: [_1]',$right)))
+                                   ($TWiki::I18N->maketext('Line: [_1]',$right)))
                           );
     }
     # unhide html comments (<!-- --> type tags)
@@ -247,50 +247,50 @@
 #| TODO: | this should move to Render.pm |
 sub _renderSequential
 {
-    my ( $session, $web, $topic, $diffType, $left, $right ) = @_;
+    my ( $web, $topic, $diffType, $left, $right ) = @_;
     my $result = '';
 
     #note: I have made the colspan 9 to make sure that it spans all columns (thought there are only 2 now)
     if ( $diffType eq '-') {
         $result .=
           _sequentialRow( '#FFD7D7',
-                          ($session->{i18n}->maketext('Deleted')),
+                          ($TWiki::I18N->maketext('Deleted')),
                           'Deleted',
-                          _renderCellData( $session, $left, $web, $topic ),
+                          _renderCellData( $left, $web, $topic ),
                           '-', '&lt;');
     } elsif ( $diffType eq '+') {
         $result .=
           _sequentialRow( '#D0FFD0',
-                          ($session->{i18n}->maketext('Added')),
+                          ($TWiki::I18N->maketext('Added')),
                           'Added',
-                          _renderCellData( $session, $right, $web, $topic ),
+                          _renderCellData( $right, $web, $topic ),
                           '+', '&gt;' );
     } elsif ( $diffType eq 'u') {
         $result .=
           _sequentialRow( undef,
-                          ($session->{i18n}->maketext('Unchanged')),
+                          ($TWiki::I18N->maketext('Unchanged')),
                           'Unchanged',
-                          _renderCellData( $session, $right, $web, $topic ),
+                          _renderCellData( $right, $web, $topic ),
                           'u', '' );
     } elsif ( $diffType eq 'c') {
         $result .=
           _sequentialRow( '#D0FFD0',
-                          ($session->{i18n}->maketext('Changed')),
+                          ($TWiki::I18N->maketext('Changed')),
                           'Deleted',
-                          _renderCellData( $session, $left, $web, $topic ),
+                          _renderCellData( $left, $web, $topic ),
                           '-', '&lt;' );
         $result .=
           _sequentialRow( undef,
-                          ($session->{i18n}->maketext('Changed')),
+                          ($TWiki::I18N->maketext('Changed')),
                           'Added',
-                          _renderCellData( $session, $right, $web, $topic ),
+                          _renderCellData( $right, $web, $topic ),
                           '+', '&gt;' );
     } elsif ( $diffType eq 'l' && $left ne '' && $right ne '' ) {
         $result .= CGI::Tr({bgcolor=>$format{l}[0],
                             class=>'twikiDiffLineNumberHeader'},
                            CGI::th({align=>'left',
                                     colspan=>9},
-                                    ($session->{i18n}->maketext('Line: [_1] to [_2]',$left,$right))
+                                    ($TWiki::I18N->maketext('Line: [_1] to [_2]',$left,$right))
                                   )
                            );
     }
@@ -308,7 +308,7 @@
 #| TODO: | move into Render.pm |
 sub _renderRevisionDiff
 {
-    my( $session, $web, $topic, $sdiffArray_ref, $renderStyle ) = @_;
+    my( $web, $topic, $sdiffArray_ref, $renderStyle ) = @_;
 
 #combine sequential array elements that are the same diffType
     my @diffArray = ();
@@ -345,11 +345,11 @@
             $next_ref = undef;
 		}
 		if ( $renderStyle eq 'sequential' ) {
-		    $result .= _renderSequential( $session, $web, $topic, @$diff_ref );
+		    $result .= _renderSequential( $web, $topic, @$diff_ref );
 		} elsif ( $renderStyle eq 'sidebyside' ) {
             $result .= CGI::Tr(CGI::td({ width=>'50%'}, ''),
                                CGI::td({ width=>'50%'}, ''));
-		    $result .= _renderSideBySide( $session, $web, $topic, @$diff_ref );
+		    $result .= _renderSideBySide( $web, $topic, @$diff_ref );
 		} elsif ( $renderStyle eq 'debug' ) {
 		    $result .= _renderDebug( @$diff_ref );
 		}
@@ -358,11 +358,11 @@
     #don't forget the last one ;)
     if ( $diff_ref ) {
         if ( $renderStyle eq 'sequential' ) {
-            $result .= _renderSequential ( $session, $web, $topic, @$diff_ref );
+            $result .= _renderSequential ( $web, $topic, @$diff_ref );
         } elsif ( $renderStyle eq 'sidebyside' ) {
             $result .= CGI::Tr(CGI::td({ width=>'50%'}, ''),
                                CGI::td({ width=>'50%'}, ''));
-            $result .= _renderSideBySide( $session, $web, $topic, @$diff_ref );
+            $result .= _renderSideBySide( $web, $topic, @$diff_ref );
         } elsif ( $renderStyle eq 'debug' ) {
             $result .= _renderDebug( @$diff_ref );
         }
@@ -375,7 +375,7 @@
 
 =pod
 
----++ StaticMethod diff( $session, $web, $topic, $query )
+---++ StaticMethod diff( )
 
 =diff= command handler.
 This method is designed to be
@@ -397,29 +397,27 @@
 =cut
 
 sub diff {
-    my $session = shift;
+    my $query = $TWiki::SESSION->{cgiQuery};
+    my $webName = $TWiki::SESSION->{webName};
+    my $topic = $TWiki::SESSION->{topicName};
 
-    my $query = $session->{cgiQuery};
-    my $webName = $session->{webName};
-    my $topic = $session->{topicName};
+    TWiki::UI::checkWebExists( $webName, $topic, 'diff' );
+    TWiki::UI::checkTopicExists( $webName, $topic, 'diff' );
 
-    TWiki::UI::checkWebExists( $session, $webName, $topic, 'diff' );
-    TWiki::UI::checkTopicExists( $session, $webName, $topic, 'diff' );
-
     my $renderStyle = $query->param('render') ||
-      $session->{prefs}->getPreferencesValue( 'DIFFRENDERSTYLE' ) ||
+      $TWiki::PREFS->getPreferencesValue( 'DIFFRENDERSTYLE' ) ||
         'sequential';
     my $diffType = $query->param('type') || 'history';
     my $contextLines = $query->param('context');
     unless( defined $contextLines ) {
-        $session->{prefs}->getPreferencesValue( 'DIFFCONTEXTLINES' );
+        $TWiki::PREFS->getPreferencesValue( 'DIFFCONTEXTLINES' );
         $contextLines = 3 unless defined $contextLines;
     }
     my $rev1 = $query->param( 'rev1' );
     my $rev2 = $query->param( 'rev2' );
 
-    my $skin = $session->getSkin();
-    my $tmpl = $session->{templates}->readTemplate( 'rdiff', $skin );
+    my $skin = $TWiki::SESSION->getSkin();
+    my $tmpl = $TWiki::TEMPLATES->readTemplate( 'rdiff', $skin );
     $tmpl =~ s/\%META{.*?}\%//go;  # remove %META{'parent'}%
 
     my( $before, $difftmpl, $after, $tail) = split( /%REPEAT%/, $tmpl);
@@ -428,14 +426,14 @@
     $after ||= '';
     $tail ||= '';
 
-    my $maxrev = $session->{store}->getRevisionNumber( $webName, $topic );
+    my $maxrev = $TWiki::STORE->getRevisionNumber( $webName, $topic );
     $maxrev =~ s/r?1\.//go;  # cut 'r' and major
 
-    $rev1 = $session->{store}->cleanUpRevID( $rev1 );
+    $rev1 = $TWiki::STORE->cleanUpRevID( $rev1 );
     $rev1 = $maxrev if( $rev1 < 1 );
     $rev1 = $maxrev if( $rev1 > $maxrev );
 
-    $rev2 = $session->{store}->cleanUpRevID( $rev2 );
+    $rev2 = $TWiki::STORE->cleanUpRevID( $rev2 );
     $rev2 = 1 if( $rev2 < 1 );
     $rev2 = $maxrev if( $rev2 > $maxrev );
 
@@ -449,13 +447,13 @@
 
     $before =~ s/%REVTITLE1%/$revTitle1/go;
     $before =~ s/%REVTITLE2%/$revTitle2/go;
-    $before = $session->handleCommonTags( $before, $webName, $topic );
-    $before = $session->{renderer}->getRenderedVersion( $before, $webName, $topic );
+    $before = $TWiki::SESSION->handleCommonTags( $before, $webName, $topic );
+    $before = $TWiki::RENDER->getRenderedVersion( $before, $webName, $topic );
 
     my $page = $before;
 
     # do one or more diffs
-    $difftmpl = $session->handleCommonTags( $difftmpl, $webName, $topic );
+    $difftmpl = $TWiki::SESSION->handleCommonTags( $difftmpl, $webName, $topic );
     my $r1 = $rev1;
     my $r2 = $rev2;
     my $isMultipleDiff = 0;
@@ -472,17 +470,17 @@
         my $rInfo = '';
         my $text;
         if ( $r1 > $r2 + 1) {
-            $rInfo = $session->{i18n}->maketext(
+            $rInfo = $TWiki::I18N->maketext(
                 "Changes from r[_1] to r[_2]", $r2, $r1);
         } else {
-            $rInfo = $session->{renderer}->renderRevisionInfo(
+            $rInfo = $TWiki::RENDER->renderRevisionInfo(
                 $webName, $topic, undef, $r1, '$date - $wikiusername' );
         }
         # eliminate white space to prevent wrap around in HR table:
         $rInfo =~ s/\s+/&nbsp;/g;
-        my $diffArrayRef = $session->{store}->getRevisionDiff(
-            $session->{user}, $webName, $topic, $r2, $r1, $contextLines );
-        $text = _renderRevisionDiff( $session, $webName, $topic,
+        my $diffArrayRef = $TWiki::STORE->getRevisionDiff(
+            $TWiki::SESSION->{user}, $webName, $topic, $r2, $r1, $contextLines );
+        $text = _renderRevisionDiff( $webName, $topic,
                                      $diffArrayRef, $renderStyle );
         $diff =~ s/%REVINFO1%/$rInfo/go;
         $diff =~ s/%TEXT%/$text/go;
@@ -493,7 +491,7 @@
     } while( $diffType eq 'history' && ( $r1 > $rev2 || $r1 == 1 ));
 
     if( $TWiki::cfg{Log}{rdiff} ) {
-        $session->writeLog( 'rdiff', $webName.'.'.$topic, "$rev1 $rev2" );
+        $TWiki::SESSION->writeLog( 'rdiff', $webName.'.'.$topic, "$rev1 $rev2" );
     }
 
     my $i = $maxrev;
@@ -510,7 +508,7 @@
 
     while( $i > 0 ) {
         $revisions .= ' '.
-          CGI::a( { href=>$session->getScriptUrl( 0, 'view', $webName, $topic,
+          CGI::a( { href=>$TWiki::SESSION->getScriptUrl( 0, 'view', $webName, $topic,
                                                   rev => $i ),
                     rel => 'nofollow' }, 'r'.$i);
         if( $i != 1 ) {
@@ -522,7 +520,7 @@
                 } else {
                     $j = $i - 1;
                     $revisions .= ' '.
-                      CGI::a( { href=>$session->getScriptUrl(
+                      CGI::a( { href=>$TWiki::SESSION->getScriptUrl(
                           0, 'rdiff', $webName, $topic,
                           rev1 => $i, rev2 => $j ),
                                 rel => 'nofollow' },
@@ -537,11 +535,11 @@
     my $tailResult = '';
     my $revTitle   = '';
     while( $i >= $rev2) {
-        $revTitle = CGI::a( { href=>$session->getScriptUrl(
+        $revTitle = CGI::a( { href=>$TWiki::SESSION->getScriptUrl(
             0, 'view', $webName, $topic, rev => $i ),
                               rel => 'nofollow' },
                             $i);
-        my $revInfo = $session->{renderer}->renderRevisionInfo( $webName, $topic, undef, $i );
+        my $revInfo = $TWiki::RENDER->renderRevisionInfo( $webName, $topic, undef, $i );
         $tailResult .= $tail;
         $tailResult =~ s/%REVTITLE%/$revTitle/go;
         $tailResult =~ s/%REVINFO%/$revInfo/go;
@@ -552,11 +550,11 @@
     $after =~ s/%CURRREV%/$rev1/go;
     $after =~ s/%MAXREV%/$maxrev/go;
 
-    $after = $session->handleCommonTags( $after, $webName, $topic );
-    $after = $session->{renderer}->getRenderedVersion( $after, $webName, $topic );
+    $after = $TWiki::SESSION->handleCommonTags( $after, $webName, $topic );
+    $after = $TWiki::RENDER->getRenderedVersion( $after, $webName, $topic );
     $page .= $after;
 
-    $session->writeCompletePage( $page );
+    $TWiki::SESSION->writeCompletePage( $page );
 }
 
 1;
